(***************************************************************************
* Bundles of Modules for Developments in Programming Language Metatheory   *
* Brian Aydemir & Arthur Charguéraud, March 2007, Coq v8.1                 *
***************************************************************************)

(** Exports the two modules non specific to metatheory but 
  necessary to complete such developments *)

Require Export Lib_Tactic Lib_FinSet.

(** Exports Variables and Environments instanciated with such Variables  *)

Require Export Metatheory_Atom.
Require Export Metatheory_Env.
Require Export Metatheory_Env_Set.
Export Env.
Export Env_Set.
Open Scope set_scope.
Open Scope env_scope.
Open Scope env_set_scope.

(** Automation: hint to use finite set reasoning to prove 
   freshness subgoals automatically. *)

Hint Extern 1 (_ \notin _) => notin_solve.

Hint Extern 1 (disjoint _ _) => disjoint_solve.

Hint Extern 1 (_ \in _ -> False) =>
  repeat match goal with
  | H: context [?x \in ?E -> False] |- _ => 
    fold (not (x \in E)) in H 
  | |- context [?x \in ?E -> False] => 
    fold (not (x \in E)) end.

Hint Extern 1 (_ <> _ :> atom) => notin_neq_solve.
Hint Extern 1 (_ <> _ :> S.elt) => notin_neq_solve.

